<?php if (!defined('ABSPATH')) {exit;}
/**
* Get unit for Variable Products 
*
* @link			https://icopydoc.ru/
* @since		1.6.0
*/

class XFAVI_Get_Unit_Offer_Variable extends XFAVI_Get_Unit_Offer {
	use XFAVI_T_Common_Contact_Info;
	use XFAVI_T_Common_Get_CatId;
	use XFAVI_T_Common_Skips;
	
	use XFAVI_T_Variable_Get_Adtype; 
	use XFAVI_T_Variable_Get_Apparel;
	use XFAVI_T_Variable_Get_Appareltype;
	use XFAVI_T_Variable_Get_Brand;
	use XFAVI_T_Variable_Get_Category;
	use XFAVI_T_Variable_Get_Condition;
	use XFAVI_T_Variable_Get_Description;
	use XFAVI_T_Variable_Get_Goods_Sub_Type;
	use XFAVI_T_Variable_Get_Goods_Type;
	use XFAVI_T_Variable_Get_Id;
	use XFAVI_T_Variable_Get_Image;
	use XFAVI_T_Variable_Get_Make;
	use XFAVI_T_Variable_Get_Model;
	use XFAVI_T_Variable_Get_OEM;
	use XFAVI_T_Variable_Get_Price;
	use XFAVI_T_Variable_Get_Size;
	use XFAVI_T_Variable_Get_Title;

	public function generation_product_xml($result_xml = '') {
		$this->feed_category_id = $this->get_catid();
		$this->get_skips();
	
		if (get_term_meta($this->get_feed_category_id(), 'xfavi_avito_standart', true) !== '') {
			$xfavi_avito_standart = get_term_meta($this->get_feed_category_id(), 'xfavi_avito_standart', true);
		} else {
			new XFAVI_Error_Log('FEED № '.$this->get_feed_id().'; WARNING: Для категории $this->get_feed_category_id() = '.$this->get_feed_category_id().' задан стандарт по умолчанию; Файл: class-xfavi-get-unit-offer-simple.php; Строка: '.__LINE__);
			$xfavi_avito_standart = 'lichnye_veshi';
		}

		switch ($xfavi_avito_standart) {
			case "lichnye_veshi": 
				$result_xml = $this->lichnye_veshi(); 
				break;
			case "dom": 
				$result_xml = $this->dom(); 
				break;
			case "tehnika": 
				$result_xml = $this->tehnika(); 
				break;	
			case "zapchasti": 
				$result_xml = $this->zapchasti(); 
				break;
			case "business": 
				$result_xml = $this->business(); 
				break;
			case "hobby": 
				$result_xml = $this->hobby(); 
				break;
			case "zhivotnye": 
				$result_xml = $this->zhivotnye(); 
				break;
			default: 
				$result_xml = $this->lichnye_veshi();
		}

		$result_xml = apply_filters('xfavi_append_variable_offer_filter', $result_xml, $this->product, $this->offer, $this->get_feed_id()); 
		$result_xml .= '</Ad>'. PHP_EOL;
		return $result_xml;

	}

	private function get_common_xml_data($result_xml = '') {
		$result_xml .= $this->get_contact_info();
		$result_xml .= $this->get_category();
		$result_xml .= $this->get_condition();

		$result_xml .= $this->get_image();
		$result_xml .= $this->get_description();
		$result_xml .= $this->get_id();
		$result_xml .= $this->get_title();

		if (class_exists('WOOCS')) { 
			$xfavi_wooc_currencies = xfavi_optionGET('xfavi_wooc_currencies', $this->get_feed_id(), 'set_arr');
			if ($xfavi_wooc_currencies !== '') {
				global $WOOCS;
				$WOOCS->set_currency($xfavi_wooc_currencies);
			}
		}		
		$result_xml .= $this->get_price();
		if (class_exists('WOOCS')) {global $WOOCS; $WOOCS->reset_currency();}
		return $result_xml;
	}

	private function lichnye_veshi($result_xml = '') {
		$result_xml .= $this->get_offer_tag();
 
		$result_xml .= $this->get_goods_type();
		$result_xml .= $this->get_apparel('Apparel', 'lichnye_veshi');
		$result_xml .= $this->get_appareltype();
		$result_xml .= $this->get_adtype();
		$result_xml .= $this->get_size();
		$result_xml .= $this->get_brand();

		$result_xml .= $this->get_common_xml_data();
		return $result_xml;
	}

	private function dom($result_xml = '') {
		$result_xml .= $this->get_offer_tag();

		$result_xml .= $this->get_goods_type();
		$result_xml .= $this->get_adtype();
		$result_xml .= $this->get_goods_sub_type();

		$result_xml .= $this->get_common_xml_data();
		return $result_xml;
	}

	private function tehnika($result_xml = '') {
		$result_xml .= $this->get_offer_tag();

		$result_xml .= $this->get_goods_type();
		$result_xml .= $this->get_adtype('AdType', 'tehnika');
		$result_xml .= $this->get_oem();

		$result_xml .= $this->get_common_xml_data();
		return $result_xml;
	}

	private function zapchasti($result_xml = '') {
		$result_xml .= $this->get_offer_tag();

		$result_xml .= $this->get_goods_type('TypeId', 'zapchasti');
		// $result_xml .= $this->get_goods_sub_type('ProductsType');
		$result_xml .= $this->get_adtype('AdType', 'zapchasti');
		$result_xml .= $this->get_oem();
		$result_xml .= $this->get_brand();
		$result_xml .= $this->get_make();
		$result_xml .= $this->get_model();

		$result_xml .= $this->get_common_xml_data();
		return $result_xml;
	}
	
	private function business($result_xml = '') {
		$result_xml .= $this->get_offer_tag();

		$result_xml .= $this->get_goods_type();

		$result_xml .= $this->get_common_xml_data();
		return $result_xml;
	}

	private function hobby($result_xml = '') {
		$result_xml .= $this->get_offer_tag();

		$result_xml .= $this->get_goods_type('GoodsType', 'hobby');
		$result_xml .= $this->get_adtype();

		$result_xml .= $this->get_common_xml_data();
		return $result_xml;
	}

	private function zhivotnye($result_xml = '') {
		$result_xml .= $this->get_offer_tag();

		$result_xml .= $this->get_goods_type('GoodsType', 'zhivotnye');

		$result_xml .= $this->get_common_xml_data();
		return $result_xml;
	}

	private function get_offer_tag() {
		return '<Ad>'. PHP_EOL;
	}
}