<?php if (!defined('ABSPATH')) {exit;}
/**
* Plugin Updates
*
* @link			https://icopydoc.ru/
* @since		1.4.3
*/

class XFAVI_Data_Arr {
	private $manager_name;
	private $data_arr = [
		array('xfavi_status_sborki', '-1', 'private'),
		array('xfavi_date_sborki', '0000000001', 'private'), // дата начала сборки
		array('xfavi_date_sborki_end', '0000000001', 'private'), // дата завершения сборки
		array('xfavi_date_save_set', '0000000001', 'private'), // дата сохранения настроек плагина
		array('xfavi_count_products_in_feed', '-1', 'private'), // число товаров, попавших в фид
		array('xfavi_file_url', '', 'private'),
		array('xfavi_file_file', '', 'private'),
		array('xfavi_errors', '', 'private'),
		array('xfavi_status_cron', 'off', 'private'),

		array('xfavi_step_export', '500', 'public'),
		array('xfavi_type_sborki', 'xml', 'public'), // тип собираемого файла xml или xls
		array('xfavi_file_ids_in_xml', '', 'public'),		
		array('xfavi_run_cron', 'off', 'public'),
		array('xfavi_ufup', '0', 'public'),
		array('xfavi_feed_assignment', '', 'public'),
		array('xfavi_whot_export', 'all', 'public'), // что выгружать (все или там где галка)
		array('xfavi_desc', 'fullexcerpt', 'public'), 
		array('xfavi_enable_tags_custom', '', 'public'),
		array('xfavi_enable_tags_behavior', 'default', 'public'),
		array('xfavi_the_content', 'enabled', 'public'),
		array('xfavi_behavior_strip_symbol', 'default', 'public'),
		array('xfavi_var_desc_priority', 'on', 'public'),
		array('xfavi_var_source_id', 'product_id', 'public'),

		array('xfavi_allowEmail', 'Да', 'public'),
		array('xfavi_contactPhone', '', 'public'),
		array('xfavi_address', '', 'public'),
		
		array('xfavi_main_product', 'other', 'public'), // какие товары продаёте
		array('xfavi_no_default_png_products', '0', 'public'),
		array('xfavi_skip_products_without_pic', '0', 'public'),
		array('xfavi_skip_missing_products', '0', 'public'),
		array('xfavi_skip_backorders_products', '0', 'public'),
		array('xfavi_size', '', 'public'),
		array('xfavi_condition', 'new', 'public'),
		array('xfavi_oem', 'disabled', 'public'),
		array('xfavi_brand', 'disabled', 'public'),
		array('xfavi_make', 'disabled', 'public'),
		array('xfavi_model', 'disabled', 'public')
	];

	public function __construct($manager_name = '', $data_arr = array()) {
		if (empty($manager_name)) {
			$blog_title = get_bloginfo('name');
			$this->manager_name = substr($blog_title, 0, 20);
		}
		if (!empty($data_arr)) {
			$this->data_arr = $data_arr;
		}
		
		array_push($this->data_arr,
			array('xfavi_managerName', $this->manager_name, 'public')
		);

		$args_arr = array($this->manager_name);
		$this->data_arr = apply_filters('xfavi_set_default_feed_settings_result_arr_filter', $this->data_arr, $args_arr);
	}

	public function get_data_arr() {
		return $this->data_arr;
	}

	// @return array([0] => opt_key1, [1] => opt_key2, ...)
	public function get_opts_name($whot = '') {
		if ($this->data_arr) {
			$res_arr = array();		
			for ($i = 0; $i < count($this->data_arr); $i++) {
				switch ($whot) {
					case "public":
						if ($this->data_arr[$i][2] === 'public') {
							$res_arr[] = $this->data_arr[$i][0];
						}
					break;
					case "private":
						if ($this->data_arr[$i][2] === 'private') {
							$res_arr[] = $this->data_arr[$i][0];
						}
					break;
					default:
						$res_arr[] = $this->data_arr[$i][0];
				}
			}
			return $res_arr;
		} else {
			return array();
		}
	}

	// @return array(opt_name1 => opt_val1, opt_name2 => opt_val2, ...)
	public function get_opts_name_and_def_date($whot = 'all') {
		if ($this->data_arr) {
			$res_arr = array();		
			for ($i = 0; $i < count($this->data_arr); $i++) {
				switch ($whot) {
					case "public":
						if ($this->data_arr[$i][2] === 'public') {
							$res_arr[$this->data_arr[$i][0]] = $this->data_arr[$i][1];
						}
					break;
					case "private":
						if ($this->data_arr[$i][2] === 'private') {
							$res_arr[$this->data_arr[$i][0]] = $this->data_arr[$i][1];
						}
					break;
					default:
						$res_arr[$this->data_arr[$i][0]] = $this->data_arr[$i][1];
				}
			}
			return $res_arr;
		} else {
			return array();
		}
	}

	public function get_opts_name_and_def_date_obj($whot = 'all') {		
		$source_arr = $this->get_opts_name_and_def_date($whot);

		$res_arr = array();	
		foreach($source_arr as $key => $value) {
			$res_arr[] = new XFAVI_Data_Arr_Helper($key, $value); // return unit obj
		}
		return $res_arr;
	}
}
class XFAVI_Data_Arr_Helper {	
	private $opt_name;
	private $opt_def_value;

	function __construct($name = '', $def_value = '') {
		$this->opt_name = $name;
		$this->opt_def_value = $def_value;
	}

	function get_name() {
		return $this->opt_name;
	}

	function get_value() {
		return $this->opt_def_value;
	}
}